class Auto:
    """
    Klasse zur Verwaltung von Autos für eine Waschstraße
    """
    def __init__(self, kennzeichen_neu):
        """
        Konstruktor für Objekte der Klasse Auto
        """
        self.kennzeichen = kennzeichen_neu

    def InformationAusgeben(self):
        """
        Gibt Information über das Auto aus.
        """
        print(self.kennzeichen)

    def KennzeichenGeben(self):
        """
        Gibt das Kennzeichen des Autos zurück
        """
        return self.kennzeichen


class Knoten:
    """
    Beschreibung der Klasse Knoten
    """
    def __init__(self, auto_neu):
        """
        Konstruktor des Knoten
        """
        self.nachfolger = None
        self.auto = auto_neu

    def NachfolgerSetzen(self, nf):
        """
        Nachfolger des Autos setzen
        """
        self.nachfolger = nf

    def NachfolgerGeben(self):
        """
        Gibt den Nachfolger des Knoten aus.
        """
        return self.nachfolger

    def DatenelementGeben(self):
        """
        Gibt das Auto zurück
        """
        return self.auto

    def InformationAusgeben(self):
        """
        Gibt Information über das Auto aus.
        """
        self.auto.InformationAusgeben()


class Warteschlange:
    """
    Beschreibung der Warteschlange
    """
    def __init__(self):
        """
        Konstruktor der Warteschlange
        """
        self.anfang = None
        self.ende = None

    def Einfügen(self, auto_neu):
        """
        Fügt ein neues Auto am Ende der Warteschlange ein.
        """
        k = Knoten(auto_neu)
        if self.anfang is None:
            self.anfang = k
        else:
            self.ende.NachfolgerSetzen(k)
        self.ende = k

    def Entfernen(self):
        """
        Entfernt das erste Auto aus der Warteschlange und gibt es zurück.
        """
        if not self.anfang is None:
            k = self.anfang
            if self.anfang == self.ende:
                self.anfang = None
                self.ende = None
            else:
                self.anfang = self.anfang.NachfolgerGeben()
            return k.DatenelementGeben()
        else:
            return None

    def InformationAusgeben(self):
        """
        Gibt Information über die Warteschlange aus.
        """
        if self.anfang is not None:
            self.anfang.InformationAusgeben()